package com.fp.persistence.pgeneral.trans;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONITEM*/
@Entity(name="TgeneTransactionItem")
@Table(name="TGENETRANSACTIONITEM")
public class TgeneTransactionItem extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionItem
*/
@EmbeddedId
private TgeneTransactionItemKey pk;
@Column(name="DESCRIPTION", nullable=false)

/**
* Descripciópn del item de la transacción Ejemplo Efectivo.
*/
private String description;

@Column(name="SHOWINPAGE", nullable=true)

/**
* null
*/
private String showinpage;

@Column(name="CALCUTATETARIFF", nullable=true)

/**
* Se utiliza en paginas, Y indica que se tiene calcular el valor de un rubor en funcion a un tarifario.
*/
private String calcutatetariff;

@Column(name="EDITABLE", nullable=true)

/**
* null
*/
private String editable;

/**Contructor por defecto*/
public TgeneTransactionItem(){
}
/**Contructor de TgeneTransactionItem
@param pPk Clave Primaria del entity
@param pDescription Descripciópn del item de la transacción Ejemplo Efectivo.
*/
public TgeneTransactionItem(TgeneTransactionItemKey pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionItem
*/
public static TgeneTransactionItem find(EntityManager pEntityManager,TgeneTransactionItemKey pKey) throws Exception{
    TgeneTransactionItem obj = pEntityManager.find(TgeneTransactionItem.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionItem
@return El objeto que referencia a la Clave primaria de TgeneTransactionItem
*/
public TgeneTransactionItemKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionItem
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionItem
*/
public void setPk(TgeneTransactionItemKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de showinpage
@return valor de showinpage*/
public String getShowinpage(){
  return showinpage;
}
/**Fija el valor de showinpage
@param pShowinpage nuevo Valor de showinpage*/
public void setShowinpage(String pShowinpage){
  showinpage=pShowinpage;
}

/**Obtiene el valor de calcutatetariff
@return valor de calcutatetariff*/
public String getCalcutatetariff(){
  return calcutatetariff;
}
/**Fija el valor de calcutatetariff
@param pCalcutatetariff nuevo Valor de calcutatetariff*/
public void setCalcutatetariff(String pCalcutatetariff){
  calcutatetariff=pCalcutatetariff;
}

/**Obtiene el valor de editable
@return valor de editable*/
public String getEditable(){
  return editable;
}
/**Fija el valor de editable
@param pEditable nuevo Valor de editable*/
public void setEditable(String pEditable){
  editable=pEditable;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionItem))return false;
    TgeneTransactionItem that = (TgeneTransactionItem) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionItem
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionItem
*/
public Object createInstance(){
 TgeneTransactionItem instance=new TgeneTransactionItem();	
 instance.setPk(new TgeneTransactionItemKey());
 return instance;
}
/**Clona la entidad TgeneTransactionItem
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionItem p=(TgeneTransactionItem)this.clone();
  p.setPk((TgeneTransactionItemKey)this.pk.cloneMe());
  return p;
}
}
